use std::net::{IpAddr, Ipv4Addr};
use std::net::{TcpListener, TcpStream};
use std::io::prelude::*;
use std::io::{Write, stdout};

use crate::sensor::Sensor;
use crate::gui;

pub fn listener(s: &Sensor, ip: IpAddr, port: u16) {
    let listener = TcpListener::bind(format!("{}:{}", ip, port)).unwrap();
    //let mut content: String = "Data: ".to_string();
    let mut content: u32;
    let mut num: u16;

    loop {
        for stream in listener.incoming() {
            let stream = stream.unwrap();
            //content = print_message(stream);
            print_message(s, stream);
 
        }
    }
}


pub fn print_message(s: &Sensor, mut stream: TcpStream) {
    let mut buffer: [u8; 4] = [0; 4];
    //let mut content: String = "".to_string();

    let mut peek = stream.peek(&mut buffer).expect("peek failed");
    loop {
        while peek >= 4 {
            stream.read(&mut buffer).unwrap();

            let swag = ((buffer[0] as u32) << 0) +
                        ((buffer[1] as u32) << 8) +
                        ((buffer[2] as u32) <<  16) +
                        ((buffer[3] as u32) <<  24);

            peek = stream.peek(&mut buffer).expect("peek failed");
            gui::print_distance(s, swag as u16);
        }
    }

}

