#![allow(dead_code)]
#![allow(warnings)]
extern crate termion;
use termion::{color, clear, cursor, style};

use termion::raw::IntoRawMode;
use std::io::Write;
use std::io::stdout;
use std::time::Duration;
use std::thread;
use rand::Rng;
use std::string::ToString;

//tcp
use std::net::{IpAddr, Ipv4Addr};
use std::net::TcpListener;
use std::net::TcpStream;
use std::io::prelude::*;


//Constants
const PRINT_DELAY: u64 = 10;
const BUFFER_SIZE: usize = 20;

mod listener;
mod tests;
mod gui;
mod sensor;

use crate::sensor::Sensor;
use tests::*;

/////////////////////////////////////////////////

fn main() {   
    //Create new sensor with GUI. Create Ip and Port to setup on.
    let s = sensor::new_sensor(400, 200, sensor::new_gui(15, 15, 70, PRINT_DELAY));
    //let ip = IpAddr::V4(Ipv4Addr::new(10, 240, 200, 171));
    let ip = IpAddr::V4(Ipv4Addr::new(127, 0, 0, 1));
    let port: u16 = 7777;

    do_stuff(&s, ip, port); // Runs the Program

    println!("Exited program!"); 
}

fn do_stuff(s: &sensor::Sensor, ip: IpAddr, port: u16) {
    gui::init_map(&s);                      // Initiates the GUI  
    tests::print_pos_rng(&s);               // Runs an RNG position function
    tests::print_pos_incremental(&s, 1);    // Runs an RNG position function
    //tests::print_pos_rng_intervals(&s, 10);     // Runs an RNG position function

    listener::listener(&s, ip, port);
 
}
