#include <Arduino.h>

int analog_pin0 = 0;
int analog_pin1 = 1;
int signal_pin = 13;

int divider = 25;

// the setup
void setup() {
  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(signal_pin, OUTPUT);
  Serial.begin(9600);
}

// the loop 
void loop() {
  float avg0 = 0;
  float avg1 = 0; 
  delay(1);
  
   avg0 = get_avg_analog(analog_pin0, signal_pin);
   avg1 = get_avg_analog(analog_pin1, signal_pin);

   //Serial.print("avg0: >>> ");
   //Serial.print(avg0);
   //Serial.print(" | ");
   //Serial.print(avg1);
   //Serial.print(" <<< :avg1");
   //Serial.println("");
   Serial.println(avg0);
  
}

float get_avg_analog(int analog_pin, int signal_pin) {
  float avg = 0;
  int count = 0;
  int val = 0;
  float recent = 0;

  //digitalWrite(signal_pin, HIGH);
  //delay(1);
  //digitalWrite(signal_pin, LOW);

  int safety = 0;

  val = analogRead(analog_pin) * 12.6;
  avg = val;
  recent = val;
  while (count < divider) {
      val = analogRead(analog_pin) * 12.6; //gets distance in mm
      if (abs(val - recent) < 300) {
          avg = avg + val;
          count = count + 1;
          recent = val;
          safety = 0;
      }
      if (safety == 20) {
          recent = val;
      }
      safety = safety + 1;
      
      delay(1);
  }
  count = 0;
  avg = avg/divider;
  return avg;
}
